commit b51b45eaf7131ec97b7fa180ffa6e8dedc24e74f
Author: Andre Vieira <andre.simoesdiasvieira@arm.com>
Date:   Mon Oct 14 16:24:07 2024 +0100

    fold-const: Fix BIT_INSERT_EXPR folding for BYTES_BIG_ENDIAN [PR116997]
    
    Fix constant folding of BIT_INSER_EXPR for BYTES_BIG_ENDIAN targets.
    
    gcc/ChangeLog:
    
            PR middle-end/116997
            * fold-const.cc (fold_ternary_loc): Fix BIT_INSERT_EXPR constant folding
            for BYTES_BIG_ENDIAN targets.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.dg/vect/pr116997.c: New test.
    
    Co-authored-by: Andrew Pinski <quic_apinski@quicinc.com>
    (cherry picked from commit 2e30e90a0c2bf8147a6d24854aa653c332c8f84f)

diff --git a/gcc/fold-const.cc b/gcc/fold-const.cc
index 1e6b573ca01..89df178c696 100644
--- a/gcc/fold-const.cc
+++ b/gcc/fold-const.cc
@@ -13652,6 +13652,8 @@ fold_ternary_loc (location_t loc, enum tree_code code, tree type,
 	{
 	  unsigned HOST_WIDE_INT bitpos = tree_to_uhwi (op2);
 	  unsigned bitsize = TYPE_PRECISION (TREE_TYPE (arg1));
+	  if (BYTES_BIG_ENDIAN)
+	    bitpos = TYPE_PRECISION (type) - bitpos - bitsize;
 	  wide_int tem = (wi::to_wide (arg0)
 			  & wi::shifted_mask (bitpos, bitsize, true,
 					      TYPE_PRECISION (type)));
diff --git a/gcc/testsuite/gcc.dg/vect/pr116997.c b/gcc/testsuite/gcc.dg/vect/pr116997.c
new file mode 100644
index 00000000000..4563fc2bfb6
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/vect/pr116997.c
@@ -0,0 +1,18 @@
+/* PR 116997.  */
+struct S0
+{
+  unsigned f0;
+  signed f2 : 11;
+  signed : 6;
+} GlobS, *Ptr = &GlobS;
+
+const struct S0 Initializer = {7, 3};
+
+int main (void)
+{
+  for (unsigned i = 0; i <= 2; i++)
+    *Ptr = Initializer;
+  if (GlobS.f2 != 3)
+    __builtin_abort ();
+  return 0;
+}

